//---------------------------------------------------------------------------
//Program Editor
//Slou k oprav a editaci vrstevnic a vygenerovn zkladnho VRML modelu z nich
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//----------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "edit.h"
#include "unit2.h"
#include "Unit4.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
const crMyCursor = 5;
const crMyDelete = 6;
//---------------------------------------------------------------------------
//konstruktor
__fastcall TForm1::TForm1(TComponent* Owner)
: TForm(Owner)
{
  chyba=-1;  //promnn pro prochzen chyb spojovn
  zvec=1.0;  //promnn pro aktuln zvten obrzku
  zrus();    //nastaven promnnch
  undok1=-1; //promnn pro undo - nepouit
  bod =-1;   //nastaven promnn pro hledn bod pi klikn na obrzek
  //nastaven pouvanch kurzor
  Screen->Cursors[crMyCursor] = LoadCursor(HInstance, "CUR1");
  Screen->Cursors[crMyDelete] = LoadCursor(HInstance, "CUR2");
  ekvidistance=10;  //nastaven ekvidistance
  protahnout=true;  //nastaven promnn pro spojovn ar
}
//---------------------------------------------------------------------------
//funkce pro pekreslen bitmapy v aplikaci
void  TForm1::Prekresli()
{
  //nastaven rozmr obrzku
  int sir=Image1->Width;
  int vys=Image1->Height;
  Image1->Canvas->Brush->Style=bsSolid;//nastaven stylu ttce
  //zobrzen blho podkladu jestlie se nezobrazuje podkladov obrzek
  if(Podklad1->Checked==false)
  {
    Image1->Canvas->Brush->Color=(TColor)0xffffff;
    Image1->Canvas->Pen->Width=1 ;
    Image1->Canvas->FillRect(Rect(0,0,Image1->Picture->Width,Image1->Picture->Height));
  }
  else //zobrazen podkladovho obrhku
  {
    Image1->Canvas->Pen->Width=3 ;
    Image1->Canvas->CopyRect( Rect(0,0, Image1->Width,Image1->Height),Image2->Canvas,Rect(ScrollBar1->Position*podbar,ScrollBar2->Position*podbar,podbar*(ScrollBar1->Position*zvec+Image1->Width)/zvec,podbar*(ScrollBar2->Position*zvec+Image1->Height)/zvec));
  }
  Image1->Canvas->Brush->Style=bsClear       ;
  //vykreslen vlastnch vrstevnic
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)==0)continue;
    if(mapa->get_vyska(i)==-1) //vrstevnice nem zadanou vku
    {
      Image1->Canvas->Font->Color=(TColor)0xff;
      Image1->Canvas->Pen->Color=(TColor)0xff;
    }
    else //vrstevnice m zadanou vku
    {
      Image1->Canvas->Pen->Color=(TColor)(mapa->get_vyska(i)*1000);
      Image1->Canvas->Font->Color=(TColor)(mapa->get_vyska(i)*1000);
      Image1->Canvas->TextOut((mapa->Get_vyska_x(i)-ScrollBar1->Position)*zvec,(mapa->Get_vyska_y(i)-ScrollBar2->Position)*zvec,mapa->get_vyska(i));
    }
    //ra se m zobrazit
    if(mapa->cara_na_obr(i,sir,vys,ScrollBar1->Position,ScrollBar2->Position,zvec))
    {

      //vlastn vykreslen ry
      Image1->Canvas->MoveTo((mapa->get_bod(i,0).get_x()-ScrollBar1->Position)*zvec,(mapa->get_bod(i,0).get_y()-ScrollBar2->Position)*zvec);
      for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
      {
        Image1->Canvas->LineTo((mapa->get_bod(i,j).get_x()-ScrollBar1->Position)*zvec,(mapa->get_bod(i,j).get_y()-ScrollBar2->Position)*zvec);
      }
    }
  }
  //zobrazen bod z kterch je vrstevnice sloen
  if(Bodynavrstevnicch1->Checked)
  {
    Image1->Canvas->Brush->Style=bsSolid;
    Image1->Canvas->Brush->Color=(TColor)0xff55;

    for(int i=0;i<mapa->get_pocetcar();i++)
    {

      for(int j=0;j< mapa->get_pocetbodu_nacare(i);j++)
      {
        Image1->Canvas->FillRect(mapa->get_bod_f(i,j,ScrollBar1->Position,ScrollBar2->Position,zvec));
      }
    }

  }
  //vykreslen spojench konc vrstevnic
  Image1->Canvas->Font->Color=(TColor)0xffff00 ;
  Image1->Canvas->Pen->Color=(TColor)0xffff00;
  for(int q=0;q<konec.get_cout();q++)
  {
    if(konec.get_spoj(q)>=0 )
    {
      Image1->Canvas->MoveTo((konec[q].get_x()-ScrollBar1->Position)*zvec,( konec[q].get_y()-ScrollBar2->Position)*zvec);
      Image1->Canvas->LineTo((konec[konec.get_spoj(q)].get_x()-ScrollBar1->Position)*zvec,(konec[konec.get_spoj(q)].get_y()-ScrollBar2->Position)*zvec);
    }
  }
  //vykreslen samostatnch bod
  int x,y,z;
  Image1->Canvas->Font->Color=(TColor)0x00 ;
  for(int q=0;q<mapa->Get_pocet3D();q++)
  {
    mapa->Get_bod3D(q,x,y,z);
    Image1->Canvas->Pixels[(x-ScrollBar1->Position)*zvec][(y-ScrollBar2->Position)*zvec]=(TColor)0;
    Image1->Canvas->TextOut((x-ScrollBar1->Position)*zvec ,(y-ScrollBar2->Position)*zvec,z);
  }
  Image3->Canvas->Brush->Style=bsSolid;
  Image3->Canvas->Draw(0,0,Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
//posunut obrzku ve vodorovnm smru scrollbarem
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
  Prekresli();
}
//---------------------------------------------------------------------------
//posunut obrzku ve svislm smru scrollbarem
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
  Prekresli();
}
//---------------------------------------------------------------------------
//Tlatko Zvtit obraz
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  zvec=zvec*2.0;
  Velikost(zvec/2);
}
//---------------------------------------------------------------------------
//Tlatko Zmenit obraz
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  zvec=zvec/2.0;
  Velikost(zvec*2);
}
//---------------------------------------------------------------------------
//Tlatko Poet chyb
//funkce prochz chyby po jedn od zatku do konce
//a nakonci zobrz hlku Prohldka dokonena
// a pokrauje od zatku
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  int i=chyba; //aktuln chyby
  do
  {
    i++;
  }
  while( konec.get_cout()>i && konec.get_spoj(i)!=-1); //zjitn dal chyby
  if(konec.get_cout()==i)
  {
    chyba=-1;
    ShowMessage("Prohldka dokonena");
  }
  else   //nastaven zobrazen na aktuln chybu
  {
    chyba=i;
    zvec=1.0;
    ScrollBar1->Max=(mapa->sirka-Image1->Width)*zvec+2;
    ScrollBar2->Max=(mapa->vyska-Image1->Height)*zvec+2;
    ScrollBar1->Position=(konec[i].get_x()*zvec-Image1->Width/2)/zvec;
    ScrollBar2->Position=(konec[i].get_y()*zvec-Image1->Height/2)/zvec;
    Prekresli();
  }
}
//---------------------------------------------------------------------------
//Obsluha udlost MouseUp na obrzku
void __fastcall TForm1::Image1MouseUp(TObject *Sender, TMouseButton Button,
                                      TShiftState Shift, int X, int Y)
{
  if(Button!=mbLeft)return; //probh pouze pi zmknut levho tlatka
  //zmna spojen vrstevnic
  if(bod!=-1 && zmenit==true )
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    double del1,del=1000;
    int i,b;
    for(i=0;i<konec.get_cout();i++) //zjitn, kter konec se m zmnit
    {

      del1=konec[i].Vzdalenost(x,y);
      if(del1<del && bod!=i)
      {
        del=del1;
        b=i;
      }
    }
    if(del<16)//nalezen konce v dostaten blzkosti
    {
      konec.Spoj_plus(bod,b,0);//vlastn spojen konc
    }
    Prekresli();  //pekreslen obrazovky
  }
  //Mazn  vrstenice
  if(  smaz==true )
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    double del1,del=1000;
    int i,b;
    for(int i=0;i<mapa->get_pocetcar();i++)//nalezen mazan vrstevnice
    {
      for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
      {
        del1=mapa->get_bod(i,j).Vzdalenost(x,y);
        if(del1<del)
        {
          b=i;
          del=del1;
        }
      }
    }
    if(del<16) //vrstevnice nalezena
    {
      mapa->Del_cara(b);  //smazan vrstevnice
      if(konec.get_cout()>0)
      {

        for(i=0;i<konec.get_cout();i++)
        {
          if(b==konec.get_cara(i))
          {
            konec.Del_bod2(i,b); //smazn jejich konc
            break;
          }
        }
      }
    }

    Prekresli();
  }
  //zvten obrazu ve vezu
  if(zvec_vyrez)
  {
    //vpoet souadnic v systmu mapy
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    int bx=(px-ScrollBar1->Position)*zvec;
    int by=(py-ScrollBar2->Position)*zvec;
    if(X!=bx && Y!=by)
    {
      //zjitn polohy a zvten vezu
      zvec=((zvec*Image1->Width/abs(X-bx))+(zvec*Image1->Height/abs(Y-by)))/2;
      int x1;
      x1=((mapa->sirka+3)*zvec-Image1->Width)/zvec;
      if(x1<=0)ScrollBar1->Max=0;
      else ScrollBar1->Max=x1;
      x1=((mapa->vyska+3)*zvec-Image1->Height)/zvec;
      if(x1<=0)ScrollBar2->Max=0;
      else ScrollBar2->Max=x1;
      //nastaven scrollbar
      ScrollBar1->Position=(((x+px)/2)*zvec-Image1->Width/2)/zvec;
      ScrollBar2->Position=(((y+py)/2)*zvec-Image1->Height/2)/zvec;
      Prekresli();
    }
  }
  //mazan ar ve vyrezu
  if(smaz_vyrez)
  {
    //vpoet souadnic v systmu mapy
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    TRect rect=TRect(x<px?x:px,y<py?y:py,x<px?px:x,y<py?py:y );
    int b;
    int i;
    //prochzen konc ar a hledn, kter se maj smazat
    for(i=0;i<konec.get_cout();i++)
    {
      if(konec[i].get_x()>rect.Left && konec[i].get_x()<rect.Right && konec[i].get_y()>rect.Top && konec[i].get_y()<rect.Bottom    )
      {
        b=konec.get_cara(i);
        mapa->Del_cara(b);
        konec.Del_bod2(i,b);
        i=i-2;
        for(int j=0;j<konec.get_cout();j++)
        {
          if(mapa->get_pocetcar()==konec.get_cara(j))
            konec.set_cara(j,b);
        }
      }
    }
    //prochzen vrstevic a hledn, kter se maj smazat
    if(konec.get_cout()<1)
    {
      for(int i=0;i<mapa->get_pocetcar();i++)
      {
        for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
        {

          if(mapa->get_bod(i,j).get_x()>rect.Left && mapa->get_bod(i,j).get_x()<rect.Right && mapa->get_bod(i,j).get_y()>rect.Top && mapa->get_bod(i,j).get_y()<rect.Bottom    )
            

          {
            mapa->Del_cara(i);//vlastn mazn
          }
        }
      }

    }
    Prekresli();
  }
  //Nastaven konce vrstevnice jako konec ry
  if(  okraj==true )
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    double del1,del=1000;
    int i,b;
    //zjitn nastavovanho konce
    for(i=0;i<konec.get_cout();i++)
    {
      del1=konec[i].Vzdalenost(x,y);
      if(del1<del)
      {
        b=i;
        del=del1;
      }
    }
    if(del<16) //nalezen konce
    {
      konec.Spoj(b);//nastaven konce
    }
    Prekresli();
  }
  //zadn vsky vrstevnice
  if(vys==true)
  {
    double del=1000,del1;
    int b;
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    //zjitn nastavovan vrstevnice
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
      {
        del1=mapa->get_bod(i,j).Vzdalenost(x,y);
        if(del1<del)
        {
          b=i;
          del=del1;
        }
      }
    }
    if(del<16)//nalezen vrstevnice
    {
      Form2->Caption="Nastavit vku";
      Form2->ShowModal(); //sputn dialogu pro zadn vky
      mapa->set_vyska(b,Form2->Edit1->Text.ToInt());
      Prekresli();
    }
  }
  //Zadn vek vrstevnic taenm pes vrstevnice
  if(dokopce==true || zkopce==true || rovina==true)
  {
    int car[50];
    int bod[50];
    int xpr[50],ypr[50];
    int pocet=0;
    double tmp;
    double k1,k2,k3,k4;
    double del=1000,del1,p,q;
    int b;
    TPoint prusicik;
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    if(x==px && y==py) 
    {
      return;    //poten i koncov bod taen je stejn
    }
    int stat;
    //hledn ar kter se k s uivatelom taenm
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      for(int j=0;j<mapa->get_pocetbodu_nacare(i)-1;j++)
      {
        stat= intersect2D_Segments(Tpoint(px,py),Tpoint(x,y),mapa->get_bod(i,j),mapa->get_bod(i,j+1),prusicik);
        if( stat>0)
        {
          //uloen nalezench vrstenic
          ypr[pocet]=prusicik.y;
          xpr[pocet]=prusicik.x;
          car[pocet]=i;
          bod[pocet]=j;
          pocet++;
        }
      }
    }
    //srovnn nalezench vrstevnic podle vzdlenosti od zatku taen my
    for(int e=0;e<pocet-1;e++)
    {
      for(int f=0;f<pocet-1-e;f++)
      {
        del=sqrt((xpr[f]-px)*(xpr[f]-px)+(ypr[f]-py)*(ypr[f]-py));
        del1=sqrt((xpr[f+1]-px)*(xpr[f+1]-px)+(ypr[f+1]-py)*(ypr[f+1]-py));
        if(del>del1)
        {
          b=car[f];
          car[f]=car[f+1];
          car[f+1]=b;
          b=bod[f];
          bod[f]=bod[f+1];
          bod[f+1]=b;
          b=ypr[f];
          ypr[f]=ypr[f+1];
          ypr[f+1]=b;
          b=xpr[f];
          xpr[f]=xpr[f+1];
          xpr[f+1]=b;
        }
      }
    }
    //nastavovn vek nalezench vrstevnic
    if(mapa->get_vyska(car[0])!=-1 && pocet>0)
    {
      for(int r=1;r<pocet;r++)
      {
        if(zkopce==true)
          mapa->set_vyska(car[r],mapa->get_vyska(car[0])-r*ekvidistance);
        else if(rovina==true)
          mapa->set_vyska(car[r],mapa->get_vyska(car[0]));
        else  mapa->set_vyska(car[r],mapa->get_vyska(car[0])+r*ekvidistance);
      }
    }
    Prekresli();
  }
  //vloen samostatnho bodu
  if(vlbod==true)
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    Form2->ShowModal();
    int z=Form2->Edit1->Text.ToInt();
    mapa->Vloz_bod3D(x,y,z);//vlastn vloen
    Prekresli();
  }
  //presun bodu lecho na vrstevnici zaenm my
  if(presunbod && bod!=-1)
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    mapa->Presun_bod2D(bvrst,bod,x,y);  //vlastn pesun
    Prekresli();

  }
  //kreslen nov vrstevnice my
  if(kresli && dole)
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    dole=false;
    novalinie->Pridej(x,y);
    if(novalinie->get_bod(0).Vzdalenost(x,y)<20)
    {
      novalinie->Pridej(novalinie->get_bod(0));
    }
    Image1->Canvas->LineTo(X,Y);
    mapa->Vloz_caru(novalinie); //uloen vrstevnice
    if(konec.get_cout()!=0) //ppadn uloen jeho konc
      konec.vloz_bod(mapa->get_pocetcar()-1,*novalinie);
    Prekresli();

  }
  //rozdlen vrstevnice na dv
  if(rozdel_v)
  {
    if(konec.get_cout()!=0) return;
    double del=100000,del1;
    int car,bod;
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    //hledn rozdlovan vrstevnice
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      for(int j=0;j<mapa->get_pocetbodu_nacare(i)-1;j++)
      {
        del1=dist_Point_to_Segment( Tpoint(x,y),mapa->get_bod(i,j),mapa->get_bod(i,j+1)) ;
        if(del1<del)
        {
          car=i;
          bod=j;
          del=del1;
        }
      }
    }
    if(del<40) //nalezen vrstenice
    {
      //test dlen vrstevnice na kraji ry
      if(bod==0 || bod==mapa->get_pocetbodu_nacare(car)-2) return;

      //vytvoen dvou novch vrstevnic a smazn t star
      delete novalinie;
      novalinie=new Hcara();
      for(int i=0;i<bod+1;i++) novalinie->Pridej(mapa->get_bod(car,i));
      mapa->Vloz_caru(novalinie);
      delete novalinie;
      novalinie=new Hcara();
      for(int i=bod+1;i<mapa->get_pocetbodu_nacare(car);i++)
        novalinie->Pridej(mapa->get_bod(car,i));
      mapa->Vloz_caru(novalinie);
      mapa->Del_cara(car);
      Prekresli();
    }
  }
  //zru samostatn bod3D
  if(zrusbod==true)
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    float del1=9999,del;
    int b;
    //hledn mazanho bodu
    for(int w=0;w<mapa->Get_pocet3D();w++)
    {
      del=(*mapa)[w].Vzdalenost(x,y);
      if(del<del1)
      {
        b=w;
        del1=del;
      }
    }
    if(del1<16) //nalezen bodu
    mapa->Zrus_bod3D(b); //zruen bodu
    Prekresli();
  }
  bod=-1;
}
//---------------------------------------------------------------------------
//obsluha udlosti zmknut tlatka myi na obrzku
void __fastcall TForm1::Image1MouseDown(TObject *Sender,
                                        TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(Button==mbRight) //pi zknut pravho tlatka myi
  {                   //se zru zadan akce(nap mazn bodu)
    zrus();
  }
  else if(Button==mbLeft)//bylo zmknuto lev tlatko myi
  {
    ix=X;
    iy=Y;
    //transformace souadnic obrzku na souadnice mapy
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    double del1,del=1000;
    int i,b,ch;
    if(kresli) //zatek kreslen nov vrstevnice
    {
      dole=true;
      delete novalinie;
      novalinie=new Hcara();
      novalinie->Pridej(x,y);
      Image1->Canvas->MoveTo(X,Y);

    }
    if(zmenit==true)  //zatek zmny spojen vrstevnic
    {
      //hledn prvnho konce pro zmnu napojen vrstevnic
      for(i=0;i<konec.get_cout();i++)
      {
        del1=konec.get_bod(i).Vzdalenost(x,y);
        if(del1<del)
        {
          b=i;
          del=del1;
        }
      }
      if(del<16) bod=b; //bod nalezen
      else bod=-1;      //bod nenalezen
    }
    px=x;
    py=y;
    del=1000;
    //nalezen budu na vrstevnici
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
      {
        del1=mapa->get_bod(i,j).Vzdalenost(x,y);
        if(del1<del)
        {
          b=i;
          ch=j;
          del=del1;
        }
      }
    }
    if(del<16)
    {
      if(presunbod) //nalezen bodu na vrstevnici pro pesun
      {
        bod=ch;
        bvrst=b;
      }
    }
    else
    {
      bod=-1;
    }
    //zatek tazen my pro hromadn zadn vek vrstenic,
    //smazn vezu nebo zvten vezu
    if(dokopce || zkopce || rovina || smaz_vyrez || zvec_vyrez)
    {
      bod=0;
    }
  }
}
//---------------------------------------------------------------------------
//Tlatko Vka zadat
void __fastcall TForm1::Button8Click(TObject *Sender)
{
  zrus(); //zru jin funkce
  Image1->Cursor=(TCursor)crMyCursor; //zmna kurzoru
  vys=true; //nastav pepna pro obsluhu funkce Vka zadat
}
//---------------------------------------------------------------------------
//Tlatko Z kopce
void __fastcall TForm1::Button9Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  zkopce=true;
}
//---------------------------------------------------------------------------
//Tlatko Smazat
void __fastcall TForm1::Button12Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyDelete;
  smaz=true;
}
//---------------------------------------------------------------------------
//tlatko Zmnit
void __fastcall TForm1::Button13Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  zmenit=true;
}
//----------------------------------------------------------------------------
//Tlatko Okraj pro zadn konce ry jako konce vrstevnice
void __fastcall TForm1::Button14Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  okraj=true;
}
//---------------------------------------------------------------------------
//Funkce pro zruen vech aktivovanch tlatek
void  TForm1::zrus()
{
  Image1->Cursor=crDefault   ;//nastaven implicitnho kurzoru
  kresli=false;
  vys=false;
  zkopce=false;
  smaz=false;
  zmenit=false;
  okraj=false;
  dokopce=false;
  rovina=false;
  vlozit=false;
  vlbod=false;
  zrusbod=false;
  presunbod=false;
  smaz_vyrez=false;
  zvec_vyrez=false;
  rozdel_v=false;
}
//---------------------------------------------------------------------------
//Tlatko Do kopce
void __fastcall TForm1::Button10Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  dokopce=true;
}
//---------------------------------------------------------------------------
//Tlatko Rovina
void __fastcall TForm1::Button11Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  rovina=true;
}
//---------------------------------------------------------------------------
//Tlatko Dal vka
//zobraz dal vrstevnici kter jet nem zadanou vku
void __fastcall TForm1::Button15Click(TObject *Sender)
{
  int i=-1;
  do   //prochz vrstevnice, a najde vrstevnice s nezadanou vkou
  {
    i++;
  }
  while(mapa->get_pocetcar()>i && mapa->get_vyska(i)!=-1);
  if( mapa->get_pocetcar()==i)//prochzen je na konci souboru
  {
    ShowMessage("Prohldka dokonena");
  }
  else //nastaven zobrazen na nalezenou vrstevnici
  {
    zvec=0.50/2.0;
    int x;
    x=((mapa->sirka)*zvec-Image1->Width)/zvec;
    if(x<=0)ScrollBar1->Max=0;
    else ScrollBar1->Max=x+2;
    x=((mapa->vyska)*zvec-Image1->Height)/zvec;
    if(x<=0)ScrollBar2->Max=0;
    else ScrollBar2->Max=x+2;
    //nastaven scrollbar
    ScrollBar1->Position=(mapa->get_bod(i,1).get_x()*zvec-Image1->Width/2)/zvec;
    ScrollBar2->Position=( mapa->get_bod(i,1).get_y()*zvec-Image1->Height/2)/zvec;
    Prekresli();
  }
}
//---------------------------------------------------------------------------
//Tlatko Poet chyb
//zjiuje kolik ar je jet nespojench                                   
void __fastcall TForm1::Button21Click(TObject *Sender)
{
  int i=-1;
  int pocet=0;
  do
  {

    i++;
    if(  konec.get_spoj(i)==-1)pocet++;
  }
  while(konec.get_cout()-1>i );
  ShowMessage("Poet chyb "+(String)pocet);
}
//---------------------------------------------------------------------------
//Pkaz otevt v nabdce Soubor
//oteve soubry s vrstevnicemi(ppona car) ,
//koncemy vrstevnic (*.kon) a samostatnmi body (*.bod)

void __fastcall TForm1::Otevt1Click(TObject *Sender)
{
  OpenDialog1->Filter = "ry (*.car)|*.car"; //nastav masku zobrazovanch soubor v dialogu Otevt
  if(OpenDialog1->Execute()) //spust otvrac dialog
  {
    Caption="Editor "+OpenDialog1->FileName;
    delete mapa; //smae starou definici vrstevnic
    mapa=new Hmapa();

    int cb,x,y,spoj,del;
    //  naten konc vrstevnic
    Soubor=OpenDialog1->FileName;
    ifstream sou((OpenDialog1->FileName.SubString(1,OpenDialog1->FileName.LastDelimiter(".") )+"kon").c_str());
    if(sou)
    {
      konec.Clear();
      konec.Nacti(sou);
      sou.close();
    }
    //naten samostatnch bod
    ifstream soubor1((OpenDialog1->FileName.SubString(1,OpenDialog1->FileName.LastDelimiter(".") )+"bod").c_str());
    if(soubor1)
    {
      mapa->Precti_Bod3D(soubor1);
      soubor1.close();
    }
    //Naten vlastnch vrstevnic
    ifstream car( OpenDialog1->FileName.c_str());
    if(!car) ShowMessage("Chyba");
    else
    {
      mapa->Precti(car);
      car.close();
    }
    //nastaven velikosti zobrazovanho obrazu mapy
    if(mapa->vyska<Image1->Height)Image1->Height=mapa->vyska;
    if(mapa->sirka<Image1->Width)Image1->Width=mapa->sirka;
    Image1->Canvas->Pen->Color=(TColor)0;
    Image1->Canvas->Font->Color=(TColor)0;
    Image1->Canvas->Font->Size=10;
    Image1->Canvas->Brush->Style=bsClear      ;
    //blokovn nkterch tlatek jestlie mapa nem nateny konce ar
    if(konec.get_cout()==0)
    {
      Button21->Enabled=false;
      Button13->Enabled=false;
      Button14->Enabled=false;
      Button4->Enabled=false;
      Pospojovat1->Enabled=false;
    }
    else //odblokovn tlatek
    {
      Button21->Enabled=true;
      Button13->Enabled=true;
      Button14->Enabled=true;
      Button4->Enabled=true;
      Pospojovat1->Enabled=true;
    }
    //odblokovn ostatnch tlatek po oteven souboru
    Podklad1->Checked=false;
    Podklad1->Enabled=false;
    ScrollBar1->Enabled=true;
    ScrollBar2->Enabled=true;
    Button2->Enabled=true;
    Button3->Enabled=true;
    Button6->Enabled=true;
    Button5->Enabled=true;
    Button12->Enabled=true;
    Button8->Enabled=true;
    Button9->Enabled=true;
    Button10->Enabled=true;
    Button15->Enabled=true;
    Button11->Enabled=true;

    ScrollBar1->Max=mapa->sirka-Image1->Width+4;
    ScrollBar2->Max=mapa->vyska-Image1->Height+4;
    Uloit1->Enabled=true;
    Uloitjako1->Enabled=true;
    pravy1->Enabled=true;
    So1->Enabled=true;
    Vky1->Enabled=true;
    Zobrazit1->Enabled=true;
    ExportdoVRML2->Enabled=true;
    Exportsouadnic1->Enabled=true;
    Tisk1->Enabled=true;
    Vloit1->Enabled=true;
    zvec=1.0; //nastaven zvten
    zrus(); //deaktivace funkce
    undok1=-1;//nastaven funkce undo-nepouito
    Image3->Picture->Bitmap->Width=Image1->Width;
    Image3->Picture->Bitmap->Height=Image1->Height;
    Prekresli();
  }
}
//---------------------------------------------------------------------------
//pkaz Tisk z nabky soubor
//pmo tiskne na aktuln tiskrnu celou mapu (pouze vrstevnice s vkami)
void __fastcall TForm1::Tisk1Click(TObject *Sender)
{
  TPrinter * Tiskarna=Printer();
  Tiskarna->BeginDoc();
  int a;
  //nastave zvten
  if(Tiskarna->PageHeight/mapa->vyska > Tiskarna->PageWidth/mapa->sirka)
    zvec=Tiskarna->PageWidth/mapa->sirka;
  else zvec=Tiskarna->PageHeight/mapa->vyska;
  Tiskarna->Canvas->Brush->Style=bsSolid;
  Tiskarna->Canvas->Brush->Style=bsClear     ;
  Tiskarna->Canvas->Font->Color=(TColor)0;
  Tiskarna->Canvas->Pen->Color=(TColor)0;
  //  tisk ar
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)==0)continue;
    if(mapa->get_vyska(i)==-1)
    {
      Tiskarna->Canvas->Font->Color=(TColor)0;
      Tiskarna->Canvas->Pen->Color=(TColor)0;
    }
    else
    {
      Tiskarna->Canvas->Pen->Color=(TColor)(mapa->get_vyska(i)*1000);
      Tiskarna->Canvas->Font->Color=(TColor)(mapa->get_vyska(i)*1000);
      Tiskarna->Canvas->TextOut((double)(mapa->Get_vyska_x(i)-ScrollBar1->Position)*zvec,(double)(mapa->Get_vyska_y(i)-ScrollBar2->Position)*zvec,mapa->get_vyska(i));
    }
    Tiskarna->Canvas->MoveTo((double)(mapa->get_bod(i,0).get_x()-ScrollBar1->Position)*zvec,(double)(mapa->get_bod(i,0).get_y()-ScrollBar2->Position)*zvec);
    for(int j=1;j<mapa->get_pocetbodu_nacare(i);j++)
    {
      Tiskarna->Canvas->LineTo((double)(mapa->get_bod(i,j).get_x()-ScrollBar1->Position)*zvec,(double)(mapa->get_bod(i,j).get_y()-ScrollBar2->Position)*zvec);
    }
  }

  Tiskarna->EndDoc();//konec tisku
}
//---------------------------------------------------------------------------
//pkaz Otevt podklad z nabdky soubor
//funkce oteve obrzek s mapou jako podklad kter se zobraz pod vrstevnicemi
void __fastcall TForm1::Otevtpodklad1Click(TObject *Sender)
{
  OpenDialog1->Filter = "Bitmap (*.bmp)|*.bmp";
  if(OpenDialog1->Execute())
  {
    Image2->Picture->LoadFromFile(OpenDialog1->FileName);
    Podklad1->Enabled=true;
    podbar=Image2->Picture->Bitmap->Width/(float)mapa->sirka;
  }
}
//---------------------------------------------------------------------------
//pkaz Podklad z nabdky Zobrazit
//zobraz nebo skryje oteven soubor s podkladem
void __fastcall TForm1::Podklad1Click(TObject *Sender)
{
  if( Podklad1->Checked) Podklad1->Checked=false;
  else Podklad1->Checked=true;
  Prekresli();
}
//---------------------------------------------------------------------------
//pkaz Smazat vrstevnici z nabdky ravy
//aktivuje funkci
void __fastcall TForm1::Smazatvrstvnici1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyDelete;
  smaz=true;
}
//---------------------------------------------------------------------------
//pkaz Spojit vrstevnice z nabdky ravy
//stejn funkce jako tlatko Spojit
void __fastcall TForm1::Spojitvrstevnice1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  zmenit=true;
}
//---------------------------------------------------------------------------
//pkaz Konec vrstevnice z nabdky ravy
//stejn funkce jako tlatko Okraj
void __fastcall TForm1::Zadatkonecvrstevnice1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  okraj=true;
}
//---------------------------------------------------------------------------
//pkaz Zobrazit dal z nabdky ravy
//stejn funkce jako tlatko Dal chyba
void __fastcall TForm1::Zovrazitdalchy1Click(TObject *Sender)
{
  Button4Click(Form1);

}
//---------------------------------------------------------------------------
//pkaz Zadat z nabdky Vky
//stejn funkce jako tlatko Vka zadat
void __fastcall TForm1::Zadat1Click(TObject *Sender)
{
  zrus();
  vys=true;
}
//---------------------------------------------------------------------------
//pkaz Z kopce z nabdky Vky
//stejn funkce jako tlatko Z kopce
void __fastcall TForm1::Zkopce1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  zkopce=true;
}
//---------------------------------------------------------------------------
//pkaz Do kopce z nabdky Vky
//stejn funkce jako tlatko Do kopce
void __fastcall TForm1::Dokopce1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  dokopce=true;
}
//---------------------------------------------------------------------------
//pkaz Rovina z nabdky Vky
//stejn funkce jako tlatko Rovina
void __fastcall TForm1::Rovina1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  rovina=true;
}
//---------------------------------------------------------------------------
//pkaz Zadat z nabdky Zobrazit dal
//stejn funkce jako tlatko Dal vka
void __fastcall TForm1::Zobrazitdal1Click(TObject *Sender)
{
  Button15Click(Form1);

}
//---------------------------------------------------------------------------
//pkaz Uloit jako.. z nabdky Soubor
//funkce ukld vrstevnice, konce vrstevnic a samostatn body
//pod nov zadanm nzvem
void __fastcall TForm1::Uloitjako1Click(TObject *Sender)
{
  SaveDialog1->Filter="cary (*.car)|*.car";
  SaveDialog1->DefaultExt="car";
  if(SaveDialog1->Execute()) //sputn Save dialogu
  {
    Caption="Editor "+SaveDialog1->FileName;
    Soubor=SaveDialog1->FileName;
    //oteven souboru
    ofstream car(SaveDialog1->FileName.c_str()     );
    mapa->Zapis_car(car);//uloen vrstevnic
    car.close();
    //uloen samostatnch bod
    ofstream soubor1((SaveDialog1->FileName.SubString(1,SaveDialog1->FileName.LastDelimiter(".") )+"bod").c_str());
    mapa->Zapis_bod3D(soubor1);
    soubor1.close();
    //uloen konc vrstenic
    ofstream sou1((SaveDialog1->FileName.SubString(1,SaveDialog1->FileName.LastDelimiter(".") )+"kon").c_str());
    for(int i=0;i<konec.get_cout();i++)
    {
      sou1<<i<<"\t"<<konec.get_bods(i);
    }
    sou1.close();
  }
}
//---------------------------------------------------------------------------
//pkaz Uloit z nabdky Soubor
//funkce ukld vrstevnice, konce vrstevnic a samostatn body
void __fastcall TForm1::Uloit1Click(TObject *Sender)
{
  //uloen konc vrstenic
  ofstream sou1((Soubor.SubString(1,Soubor.LastDelimiter(".") )+"kon").c_str());
  for(int i=0;i<konec.get_cout();i++)
  {
    sou1<<i<<"\t"<<konec.get_bods(i);
  }
  sou1.close();
  //uloen vrstevnic
  ofstream car(Soubor.c_str());
  mapa->Zapis_car(car);
  car.close();
  //uloen samostatnch bod
  ofstream soubor1((Soubor.SubString(1,Soubor.LastDelimiter(".") )+"bod").c_str());
  mapa->Zapis_bod3D(soubor1);
  soubor1.close();
}
//---------------------------------------------------------------------------
//pkaz Export souadnic z nabdky Soubor
//funkce exportuje body v modelu do souboru jako seznam souadnic
//ve fomtu x y z, kladn osa x m na vchod osa y m na jih
void __fastcall TForm1::Exportsouadnic1Click(TObject *Sender)
{
  SaveDialog1->Filter="Souadnice xyz (*.txt)|*.txt";
  SaveDialog1->DefaultExt="car";
  if(SaveDialog1->Execute())
  {
    ofstream car(SaveDialog1->FileName.c_str());
    int cb=1;
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      if(mapa->get_pocetbodu_nacare(i)==0)continue;
      for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
      {
        car<<cb<<"\t"<<mapa->get_bod(i,j)<<"\t"<<mapa->get_vyska(i)<<endl;
        cb++;
      }
    }
  }
}
//---------------------------------------------------------------------------
//pkaz Pospojovat z nabdky Spojovn
//funkce pospojuje vrstenice (zmiz modr ry z obrzku )
//funkce funguje je pokud jsou vechny konce spojen nebo definovan jako konec vrstenic
void __fastcall TForm1::Pospojovat1Click(TObject *Sender)
{
  int x1,y1;
  Hmapa *tmpm = new Hmapa();
  double uh;
  int ca; //ca je index aktualniho konce
  int kontrola;
  for(int i=0;i<konec.get_cout();i++) //prohled konce
  {
    //i je index prohledavani od zacatku do konce
    //najdi konce ry definovan -3
    if(konec.get_spoj(i)!=-3||konec.get_Smaz(i))continue;
    tmpm->Novacara();
    konec[i].Cti(x1,y1);
    if(protahnout) Okraj(x1,y1,konec.get_smer(i),mapa->vyska,mapa->sirka);
    if(x1!=konec[i].get_x() ||y1!=konec[i].get_y())
    tmpm->Pridej_bod_na_posledni_caru(x1,y1);
    ca=i;
    kontrola=0;
    do
    {
      kontrola++;
      //ladc funkce
      if(kontrola>1000)ShowMessage("chyba v programu");
      //pipoj ru
      if(mapa->get_bod(konec.get_cara(ca),0)==konec[ca])
      {
        for(int l=0;l<mapa->get_pocetbodu_nacare(konec.get_cara(ca));l++)
        {
          tmpm->Pridej_bod_na_posledni_caru(mapa->get_bod(konec.get_cara(ca),l));
        }
      }
      else
      {
        for(int l=mapa->get_pocetbodu_nacare(konec.get_cara(ca))-1;l>=0;l--)
        {
          tmpm->Pridej_bod_na_posledni_caru(mapa->get_bod(konec.get_cara(ca),l));
        }
      }
      konec.set_Smaz(ca);//zma konce spojen ry
      for(int c=0;c<konec.get_cout();c++)//najd dal ru na konci spojovan ry
      {
        if(c==ca||konec.get_Smaz(c))continue;
        if(konec.get_cara(c)==konec.get_cara(ca))
        {
          ca=konec.get_spoj(c);
          konec[c].Cti(x1,y1);
          uh=konec.get_smer(c);
          konec.set_Smaz(c);
          break;
        }
      }


    }
    while(ca!=-3); //spojuj ry dokud nenalezne konec
    //Jestlie je v dialogu Nastaven zakrtuto prothnout
    //prothne konce vrstenic a na okraj mapy
    if(protahnout)   Okraj(x1,y1,uh,mapa->vyska,mapa->sirka);
    if(x1!=tmpm->get_posledi_bod2D().get_x() ||y1!=tmpm->get_posledi_bod2D().get_y()) //  if(x1!=cary1.cary[cary1.count].bod[cary1.cary[cary1.count].count-1].x ||y1!=cary1.cary[cary1.count].bod[cary1.cary[cary1.count].count-1].y)
      tmpm->Pridej_bod_na_posledni_caru(x1,y1);//    cary1.Pridej(x1,y1);
  }

//obdobnm zpsobem se pospojuj vrstevnice tvoc kruh
  for(int i=0;i<konec.get_cout();i++)
  {
    if( konec.get_Smaz(i))continue;
    tmpm->Novacara();
    ca=i;
    do
    {
      if(mapa->get_bod(konec.get_cara(ca),0)==konec[ca])

      {
        for(int l=0;l<mapa->get_pocetbodu_nacare(konec.get_cara(ca));l++)
        {
          tmpm->Pridej_bod_na_posledni_caru(mapa->get_bod(konec.get_cara(ca),l));
        }
      }
      else
      {
        for(int l=mapa->get_pocetbodu_nacare(konec.get_cara(ca))-1;l>=0;l--)
        {
          tmpm->Pridej_bod_na_posledni_caru(mapa->get_bod(konec.get_cara(ca),l));
        }
      }
      konec.set_Smaz(ca);
      for(int c=0;c<konec.get_cout();c++)
      {
        if(c==ca||konec.get_Smaz(c))continue;
        if(konec.get_cara(c)==konec.get_cara(ca))
        {
          ca=konec.get_spoj(c);
          konec.set_Smaz(c);
          break;
        }
      }
    }
    while(!konec.get_Smaz(ca));
    tmpm->Pridej_bod_na_posledni_caru(tmpm->get_bod(tmpm->get_pocetcar()-1,0));
    tmpm->set_kolo(tmpm->get_pocetcar()-1);
  }
  mapa->Zapis_car(tmpm);
  delete tmpm;
  konec.Clear();
  Prekresli();
  ShowMessage("Hotovo");
}
//---------------------------------------------------------------------------
//funkce, kter obsluhje udlost  kliknut na nabdku pravy
//funkce nepouita
void __fastcall TForm1::pravy1Click(TObject *Sender)
{
 /* if(undok1==-1)
    Zp1->Enabled=false;
  else Zp1->Enabled=true;    */
}
//---------------------------------------------------------------------------
//pkaz Pevzorkovat z nabdky Spojovn
//funkce zru pebyten body na vrstenicch podle zadanho kritria
//tm se zn velikost souboru s vrstenicemi
// a zrychl se generovn VRML modelu
//funkce probr postupn dvojice bod na vrstenici
//a st dlky kolmic mezilehlch bod
//jestlie souet dlek a dlka stanien nepeshne danou mez
//funkce tyto mezilehl body smae
void __fastcall TForm1::Pevzorkovat1Click(TObject *Sender)
{

  double a1,a2;
  int po;
  double odchylka,dalka;
  Form2->Label1->Caption="Vzorkovac kriterium";
  Form2->Edit1->Text="5";
  Form2->ShowModal();
  int zkresleni=Form2->Edit1->Text.ToInt()*100;
  for(int i=0;i<mapa->get_pocetcar();i++)
  {   //i je index prohledavani od zacatku do konce
    //vynechn ar sloench z mn ne pti bod
    if(mapa->get_pocetbodu_nacare(i)<5)continue;
    for(int l=0;l<mapa->get_pocetbodu_nacare(i)-2;l++)
    {
      po=1;
      do
      {
        if(mapa->get_bod(i,l)==mapa->get_bod(i,l+po+1))
        {
          break;
        }
        odchylka=0;
        mapa->get_koef(a1,a2,i,l,l+po+1);
        dalka=mapa->get_bod(i,l).Vzdalenost(mapa->get_bod(i,l+po+1));
        for(int j=0;j<po && j<mapa->get_pocetbodu_nacare(i)-1-po-l;j++)
        {
          //vpoet a stn kolmic mezilehlch bod
          odchylka=odchylka+fabs(mapa->get_odchlka(a1,a2,i,l,l+1+j));

        }
        po++;
      }
      while((odchylka*dalka)<zkresleni && po<mapa->get_pocetbodu_nacare(i)-1-l);
      for(int p=l+1;p<l+po-1;p++)
      {
        mapa->del_bod2D(i,l+1);//mazn mezilehlch bod
      }
    }
  }
  Prekresli();
  ShowMessage("Hotovo");
}
//---------------------------------------------------------------------------
//obsluha udlosti kliknut na nabdku Spojovn
//zjist jestli je v map jet nespojen vrstenice
//a podle toho zpstupn pkaz Pospojovat
void __fastcall TForm1::So1Click(TObject *Sender)
{
  if(konec.get_cout()>0)
  {
    int i=-1;
    int pocet=0;
    do
    {
      i++;
      if( konec.get_spoj(i)==-1)pocet++;
    }
    while(konec.get_cout()-1>i );
    if(pocet==0 && konec.get_cout()>0) Pospojovat1->Enabled=true;
    else Pospojovat1->Enabled=false;
  }
  else
  {
    Pospojovat1->Enabled=false;
  }
}
//---------------------------------------------------------------------------
//obsluha udlosti pohyb my po obrzku mapy
void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift,
                                        int X, int Y)
{
  if(zmenit==true && bod!=-1) //kresl ru pedstavujc nov spojen st vrstevnic
  {
    Image1->Canvas->Brush->Style=bsClear;
    TRect r(0,0,Image1->Width,Image1->Height  );
    Image1->Canvas->CopyRect(r,Image3->Canvas,r);
    Image1->Canvas->MoveTo((konec[bod].get_x()-ScrollBar1->Position)*zvec, (konec[bod].get_y()-ScrollBar2->Position)*zvec);
    Image1->Canvas->LineTo(X,Y);
  }
  else if(presunbod  && bod!=-1) //kresl vektor pesunu bodu na vrstenici
  {
    Image1->Canvas->Brush->Style=bsClear;
    TRect r(0,0,Image1->Width,Image1->Height  );
    Image1->Canvas->CopyRect(r,Image3->Canvas,r);
    Image1->Canvas->MoveTo((mapa->get_bod(bvrst,bod).get_x()-ScrollBar1->Position)*zvec,(mapa->get_bod(bvrst,bod).get_y()-ScrollBar2->Position)*zvec);
    Image1->Canvas->LineTo(X,Y);
  }
  //kresl ru pedstavujc spdnici p hromadnm zadvn vek
  else if(( zkopce==true ||dokopce==true||rovina==true)&& bod!=-1)
  {
    Image1->Canvas->Brush->Style=bsClear;
    TRect r(0,0,Image1->Width,Image1->Height  );
    Image1->Canvas->CopyRect(r,Image3->Canvas,r);
    Image1->Canvas->MoveTo((px-ScrollBar1->Position)*zvec, (py-ScrollBar2->Position)*zvec);
    Image1->Canvas->LineTo(X,Y);
  }
  //kresl obdlnk reprezentujc vez pro zvden nebo smazn vrstenic
  else if((smaz_vyrez ||zvec_vyrez)&& bod!=-1)
  {
    Image1->Canvas->Brush->Style=bsClear;
    TRect r(0,0,Image1->Width,Image1->Height  );
    Image1->Canvas->CopyRect(r,Image3->Canvas,r);
    TRect rect=TRect(X<ix?X:ix,Y<iy?Y:iy,X<ix?ix:X,Y<iy?iy:Y );
    Image1->Canvas->Rectangle(rect);
  }
  //kresl a ukld nov tvoenou vrstenici
  else if(kresli && dole)
  {
    int x =(X+ ScrollBar1->Position*zvec)/zvec;
    int y =(Y+ ScrollBar2->Position*zvec)/zvec;
    novalinie->Pridej(x,y);
    Image1->Canvas->LineTo(X,Y);
  }
}
//---------------------------------------------------------------------------
//pomocn funkce pro ukazatel na funkci
//pouit jako parametr voln externch funkc
void Postup()
{
  Form1->ProgressBar1->StepIt();
}
//---------------------------------------------------------------------------
//pkaz Vloit z nabdky Bod
//aktivuje funkci
void __fastcall TForm1::Bod1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  vlbod=true;
}
//---------------------------------------------------------------------------
//pkaz Zruit z nabdky Bod
void __fastcall TForm1::Zruit1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyDelete;
  zrusbod=true;
}
//---------------------------------------------------------------------------
//Destruktor
__fastcall TForm1::~TForm1()
{
  delete mapa;
  // Image4->Picture->SaveToFile("D:\\do Skoly\\MARSout.BMP");
}
//udlost volan pe uzavenm formule,
//kter se pt jestli me bt formult zaven
//zde je vloen dotaz jestli je soubor uloen
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if(Soubor!="")
  {
    int i=Application->MessageBox(("Uloit soubor "+Soubor).c_str(),"Dotaz" ,MB_YESNOCANCEL|MB_ICONQUESTION);
    if(i==6 )
    {
      Uloit1Click(Form1);
      CanClose=true;
    }
    else if(i==2)
    {
      CanClose=false;
    }
    else if(i==7  ) CanClose=true;
  }
}
//---------------------------------------------------------------------------
//Pkaz Body na vrstenicch z nabdky Zobrazit
//aktivuje zobrazen bod z kterch jsou tvoen vrstenice
void __fastcall TForm1::Bodynavrstevnicch1Click(TObject *Sender)
{
  if( Bodynavrstevnicch1->Checked) Bodynavrstevnicch1->Checked=false;
  else Bodynavrstevnicch1->Checked=true;
  Prekresli();
}
//---------------------------------------------------------------------------
//funkce vypote sprvn nastaven zobrazen obrazu mapy pi zvtovn nebo zmenovn
//zvecmin pvodn zvten
void TForm1::Velikost(double zvecmin)
{
  int x;
  x=((mapa->sirka+3)*zvec-Image1->Width)/zvec;
  if(x<=0)ScrollBar1->Max=0;
  else ScrollBar1->Max=x;
  x=((mapa->vyska+3)*zvec-Image1->Height)/zvec;
  if(x<=0)ScrollBar2->Max=0;
  else ScrollBar2->Max=x;
  int a =(Image1->Width/2+ ScrollBar1->Position*zvecmin)/zvecmin;
  int b =(Image1->Height/2+ ScrollBar2->Position*zvecmin)/zvecmin;
  ScrollBar1->Position=(a*zvec-Image1->Width/2)/zvec;
  ScrollBar2->Position=( b*zvec-Image1->Height/2)/zvec;
  Prekresli();
}
//---------------------------------------------------------------------------
//Pkaz Pesunout vrchol z nabdky pravy
//aktivuje funkci pro pesun budu na vrstenici
void __fastcall TForm1::Psunoutvrchol1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  presunbod=true;
}
//---------------------------------------------------------------------------
//Pkaz Nastaven z nabdky pravy
//zobraz dialog s nastavenm ekvidistance pouit pi hromadnm zadvn vek
//a prtaen pro funkci Pospojovat kter prothne konce vrstenic a na okraj mapy
void __fastcall TForm1::Nastaven1Click(TObject *Sender)
{
  Form4->ShowModal();
  if(Form4->zavrit)
  {
    ekvidistance=Form4->Edit2->Text.ToInt();
    protahnout=Form4->CheckBox1->Checked;
  }
  else
  {
    Form4->Edit2->Text=ekvidistance;
    Form4->CheckBox1->Checked=protahnout;

  }
}
//---------------------------------------------------------------------------
//Pkaz Smazat vez z nabdky pravy
//stejn vznam jako tlatko Smazat vez
void __fastcall TForm1::Smazatvez1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyDelete;
  smaz_vyrez=true;
}
//---------------------------------------------------------------------------
//Tlatko Smazat vez
//aktivuje funkci, kter mae vrstevnice jejech konce jsou ve vezu
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyDelete;
  smaz_vyrez=true;
}
//---------------------------------------------------------------------------
//Tlatko Vez zvtit
//aktivuje funkci kter zbt zobrazen mapy podle zadanho vezu
void __fastcall TForm1::Button6Click(TObject *Sender)
{
  zrus();

  Image1->Cursor=crCross;
  zvec_vyrez=true;
}
//---------------------------------------------------------------------------
//Tlatko oprava chyb
//oprav chyby zpsoben programem pi spojovn
//ladc funkce
void __fastcall TForm1::Button7Click(TObject *Sender)
{
  for(int i=0;i<konec.get_cout();i++)
  {
    if(konec.get_spoj(i)<0)continue;
    if(i!=konec.get_spoj(konec.get_spoj(i)))
    {
      konec.set_spoj(i);
     ShowMessage("chyba"+(String)i);
    }
  }
  ShowMessage("Hotovo "+(String)mapa->Pocet_vsech_bodu());
}
//---------------------------------------------------------------------------
//pkaz Znovu pospojovat z nabdky Spojovn
//znovu vytvo a pokus se spojit ry
//zskan jinak ne vektorizac
//funkce stejn jako v programu Vektorizator
void __fastcall TForm1::Znovupospojovat1Click(TObject *Sender)
{
 /* nedodlan
  Hcara* c=new Hcara();
   for(int i=0;i<mapa->get_pocetcar();i++){
     for(int j=0;j<mapa->get_pocetcar();j++){
       if(i==j)continue;
       if(mapa->get_bod(i,0)==mapa->get_bod(j,0)){
         c->clear();
         for(int k=mapa->get_pocetbodu_nacare(i)-1;k>=0;k--){
          c->Pridej(mapa->get_bod
         }
       }
     }

   }       */



    float uhel,uhel1; //s, s1
    float del,del1,del2;
    int na_konec;     //co
    int i2=-1;
    int pocet;

    konec.Alloc(mapa->get_pocetcar()*2);
    for(int i=0;i<mapa->get_pocetcar();i++)
    {
      konec.bod(i,mapa->get_cara(i));
    }
    ProgressBar1->Max=konec.get_cout()*3;
    ProgressBar1->Position=0;
    //hledn nejbli ry
    for(int k=0;k<3;k++)
      for(int i=0;i<konec.get_cout();i++)
    {
      ProgressBar1->StepIt();
      del=1000000;
      for(int j=i+1;j<konec.get_cout();j++)
      {
        del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
        del2=konec.get_bods(i).Trans(del1/2).Vzdalenost(konec.get_bods(j).Trans(del1/2));
        if(del1<del2) continue;
        del1=del1+del2;
        uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
        if(del1<del)
        {
          del=del1;
          na_konec=j;
          uhel1=uhel;
        }
      }
      if((del<45 && uhel1<70.0) ||(del<80 && uhel1<15.0) )
      {
        if(konec.get_spoj(na_konec)==-1 || konec.get_spoj(na_konec)==-3)
        {
          konec.Spoj(i,na_konec,del);
        }
        else
        {
          if(del*1.2< konec.get_del(na_konec))
          {
            konec.Spoj_plus(i,na_konec,del);
          }
        }
      }
    }

    //hledn ry ve vtm okol
    for(int k=0;k<3;k++)
      for(int i=0;i<konec.get_cout();i++)
    {
      ProgressBar1->StepIt();
      del=1000000;
      if( konec.get_spoj(i)==-3)continue;
      for(int j=0;j<konec.get_cout();j++)
      {
        if(i!=j &&  konec.get_spoj(j)!=-3)
        {
          del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
          del2=konec.get_bods(i).Trans(del1).Vzdalenost(konec.get_bods(j));
          if(del1<del2 ) continue;
          del1=del1+1.0*del2;
          uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
          if(uhel>150)
            del1=del1*uhel/75.0;
          if(del1<del)
          {
            del=del1;
            na_konec=j;
            uhel1=uhel;
          }
        }
      }
      if(del<500 )
      {
        if(konec.get_spoj(na_konec)==-1 && konec.get_spoj(i)==-1)
        {
          konec.Spoj(i,na_konec,del);
        }
        else
        {
          if(del*1.1< konec.get_del(na_konec))
          {
            konec.Spoj_plus(i,na_konec,del);
          }
        }
      }
    }

    //  Hledn ar na okraji
    int pr;
    for(int i=0;i<konec.get_cout();i++)
    {
      ProgressBar1->StepIt();
      pr=0;
      if(konec.get_spoj(i)==-1)
      {
        Hbod2D A=konec[i].Trans(400,konec.get_smer(i));
        if(A.get_x()<0 || A.get_y()<0 || A.get_x()>mapa->sirka || A.get_y()>mapa->vyska)
        {
          for(int j=0;j<konec.get_cout();j++)
          {
            if(konec.get_spoj(j)>=0)
              pr=  intersect(A,konec.get_bods(i),konec.get_bods(j),konec.get_bods(konec.get_spoj(j)) );
            if(pr==1)
              break;
          }
          if(pr!=1)
          {
            for(int w=0;w<mapa->get_pocetcar();w++)
            {
              for(int j=1;j<mapa->get_pocetbodu_nacare(w)-1;j++)
              {
                pr=  intersect(A,konec.get_bods(i),mapa->get_bod(w,j),mapa->get_bod(w,j+1));
                if(pr==1)
                {
                  break;
                }
              }
              if(pr==1)break;
            }
            if(pr!=1)     konec.Spoj(i);
          }
        }
      }
    }

    for(int i=0;i<konec.get_cout();i++)
    {
      if( konec.get_spoj(i)>=0)continue;
      ProgressBar1->StepIt();
      del=1000000;
      for(int j=0;j<konec.get_cout();j++)
      {
        if( konec.get_spoj(j)>=0)continue;
        if(i!=j )
        {
          del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
          del2=konec.get_bods(i).Trans(del1/2).Vzdalenost(konec.get_bods(j).Trans(del1/2));
          if(del1<del2) continue;
          del1=del1+del2;
          uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
          if(del1<del)
          {
            del=del1;
            na_konec=j;
            uhel1=uhel;
          }
        }
      }
      if(del!=1000000)
        if(konec.get_spoj(na_konec)!=konec.get_spoj(i) && del<=30 )
      {
        if(konec.get_spoj(na_konec)==-1 ||konec.get_spoj(na_konec)==-3)
        {
          konec.Spoj(i,na_konec,del);
        }
        else
        {
          if(del*1.2<konec.get_del(na_konec))
          {
            konec.Spoj_plus(i,na_konec,del);
          }
        }
      }
    }
    i2=-1;
    pocet=0;
    do
    {
      i2++;
      if(konec.get_spoj(i2)==-1)pocet++;
    }
    while(konec.get_cout()  >i2 );
    ShowMessage("Poet chyb "+(String)pocet);
    Prekresli();



}
//---------------------------------------------------------------------------
//Pkaz Nov vrstevnice z nabky pravy
// aktivuje funkci, kter tvo nov vrstevnice
void __fastcall TForm1::Novvrstevnice1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  kresli=true;
}
//---------------------------------------------------------------------------
//Pkaz Export do VRML z nabdky Soubor
//spout generovn VRML modelu
void __fastcall TForm1::ExportdoVRML2Click(TObject *Sender)
{
  SaveDialog1->Filter="WRML (*.wrl)|*.wrl";
  SaveDialog1->DefaultExt="wrl";
  if(SaveDialog1->Execute())
  {
    Form3->ShowModal();
    if(Form3->RadioButton1->Checked)  vysk_map();
    else troj();
  }
}
//---------------------------------------------------------------------------
//Pkaz Rozdlit vrstevnici z nabdky pravy
//aktivuje funkci rozdlen vrstevnice na dv
//v zadanm bod
void __fastcall TForm1::Rozdlitvrstevnici1Click(TObject *Sender)
{
  zrus();
  Image1->Cursor=(TCursor)crMyCursor;
  rozdel_v=true;
}
//---------------------------------------------------------------------------
//funkce generujc VRML model tvoen uzlem IndexFaceSet

void TForm1::troj()
{
  void (*f)(void);//ukazatel na funki

  f=Postup; //zskn adresy funcke, kterou ped funkci Mnozina_ploch
   {
    float zkresleni=Form3->Edit1->Text.ToDouble();
    mapa_troj map_torj;
    ProgressBar1->Step=1;
    ProgressBar1->Max=mapa->Pocet_vsech_bodu()*2.5;
    //vol funkci generujc trojhelnkovou s -
    int poctroj= Mnozina_ploch(mapa,map_torj, f,Form3->Edit2->Text.ToInt())  ;
    ofstream soubor(SaveDialog1->FileName.c_str()  );
    //generuje VRML model
    vrml_file* vrml_soubor=new vrml_file();
    vrml_soubor->Add_node(new VRML_NAVIGATIONINFO());
    // VRML_BACKGROUND* s=new VRML_BACKGROUND() ;
    vrml_soubor->Add_node(new VRML_BACKGROUND(vrml_color(0,0,1),vrml_color(0.6,0.8,1)
                          ,vrml_color(1,1,1),1.5,1.57,vrml_color(1,1,0.3),vrml_color(0.7,0.8,0),vrml_color(0.3,0.5,0),1.4,1.57 ));
    vrml_soubor->Add_node(new VRML_POINTLIGHT());
    vrml_soubor->Add_node(new VRML_VIEWPOINT());
    VRML_INDEXEDFACESET* model=new VRML_INDEXEDFACESET();

    model->vyska=mapa->vyska;
    model->sirka=mapa->sirka;
    model->coord=map_torj.bod;
    model->num_coord=map_torj.pocbod;
    model->mojetroj=map_torj.triangl;
    model->num_troj=poctroj;
    model->zkresleni=zkresleni;
    model->creaseAngle=2;
    //  VRML_IMAGETEXTURE* =new VRML_IMAGETEXTURE("makag.jpg");
    VRML_APPEARANCE* appear=new VRML_APPEARANCE();
    appear->material=new VRML_MATERIAL();
    appear->texture=new VRML_IMAGETEXTURE(ExtractFileName  (SaveDialog1->FileName.SubString(1,SaveDialog1->FileName.LastDelimiter(".") )+"jpg").c_str());
    VRML_SHAPE* shape=new VRML_SHAPE();
    shape->appearance=appear;
    shape->geometry=model;
    VRML_TRANSFORM* trans=new VRML_TRANSFORM();
    trans->children[0]=shape;
    trans->mum_children++;
    vrml_soubor->Add_node(trans);
    //uloen modelu
    vrml_soubor->Print(soubor);
    soubor.close();
    ShowMessage("Hotovo");
  }
}
//---------------------------------------------------------------------------
//generuje VRML model tvoen uzlem ElevationGrid
void TForm1::vysk_map()
{
  void (*f)(void);
  f=Postup;

 //zjitn hustoty vkov st
  const int sloupce=Form3->Edit2->Text.ToInt();
  const int radky=Form3->Edit3->Text.ToInt();
  float zkresleni=Form3->Edit1->Text.ToDouble();
  //alokace pamti
  float** vys =new float* [radky];
  int x1,x2,y1,y2,c1,bodcislo[4];
  for(int i=0;i<radky;i++)
  {         //y
    vys[i] = new float [sloupce];           //x
  }
  ProgressBar1->Position=0;
  ProgressBar1->Max=radky ;
  ProgressBar1->Step=1;
  //voln funkce, kter napln pole vek vkami
  Vyskova_mapa(mapa,vys,sloupce,radky, f,ekvidistance);
  ofstream soubor(SaveDialog1->FileName.c_str()  );
  //generovn modelu
  vrml_file* vrml_soubor=new vrml_file();
  vrml_soubor->Add_node(new VRML_NAVIGATIONINFO());
  vrml_soubor->Add_node(new VRML_BACKGROUND(vrml_color(0,0,1),vrml_color(0.6,0.8,1)
                        ,vrml_color(1,1,1),1.5,1.57,vrml_color(1,1,0.3),vrml_color(0.7,0.8,0),vrml_color(0.3,0.5,0),1.4,1.57 ));
  vrml_soubor->Add_node(new VRML_POINTLIGHT());
  vrml_soubor->Add_node(new VRML_VIEWPOINT());
  VRML_ELEVATIONGRID* sit=new VRML_ELEVATIONGRID(mapa->sirka/zkresleni/(sloupce-1),mapa->vyska/zkresleni/(radky-1),sloupce,radky);
  sit->height=vys;
  sit->creaseAngle=2;
  VRML_APPEARANCE* appear=new VRML_APPEARANCE();
  appear->material=new VRML_MATERIAL();
  appear->texture=new VRML_IMAGETEXTURE(ExtractFileName  (SaveDialog1->FileName.SubString(1,SaveDialog1->FileName.LastDelimiter(".") )+"jpg").c_str());
  appear->textureTransform=new VRML_TEXTURETRANSFORM(1,-1);
  VRML_SHAPE* shape=new VRML_SHAPE();
  shape->appearance=appear;
  shape->geometry=sit;
  VRML_TRANSFORM* trans=new VRML_TRANSFORM();
  trans->children[0]=shape;
  trans->mum_children++;
  vrml_soubor->Add_node(trans);
  vrml_soubor->Print(soubor); //uloen modelu
  soubor.close();
  ShowMessage("Hotovo");


}



